package ycapikey

import (
	"context"
	"regexp"

	"a.yandex-team.ru/cloud/iam/accessservice/client/iam-access-service-client-go/v1"
	"a.yandex-team.ru/security/ant-secret/web/internal/validator"
	"a.yandex-team.ru/security/ant-secret/web/internal/ycauth"
	"a.yandex-team.ru/security/libs/go/simplelog"
)

var keyRe = regexp.MustCompile("^AQVN[A-Za-z0-9_-]{36}$")

func Match(ctx validator.Context) bool {
	return keyRe.MatchString(ctx.Secret)
}

func Validate(ctx validator.Context) (*validator.Info, bool, bool) {
	subject, err := ycauth.Authenticate(context.Background(), cloudauth.NewAPIKey(ctx.Secret))
	if err != nil {
		simplelog.Error("unable to check yc api key", "err", err)
		return nil, false, false
	}

	if subject == nil {
		return nil, false, true
	}

	return ycauth.PutSubjectToValidInfo(subject, &validator.Info{Type: "YCApiKey"}), true, true
}
