echo "[common]
log_path: $2/c3po.log
tls_ca_certs_bundle:/etc/ssl/certs/
dev_env = false

[calendar]
url: http://calendar-api.tools.yandex.net/internal

[st]
token: $c3po_token
url: https://st-api.yandex-team.ru
ua: C3-PO_Robot

[molly]
token: $c3po_token
url: https://molly.yandex-team.ru/api

[abc]
token: $c3po_token
url: https://abc-back.yandex-team.ru/api/v4
ua: C3-PO_Robot

[idm]
token: $c3po_token
url: https://idm-api.yandex-team.ru/api/v1

[sentry]
dsn: $c3po_sentry

[gap]
token: $c3po_token
url: https://staff.yandex-team.ru/gap-api/api
ua: C3-PO_Robot

[staff]
token: $c3po_token
url: https://staff-api.yandex-team.ru/v3
ua: C3-PO_Robot

[appchecker]
token: 123
url: https://appcheck.yandex-team.ru

[impulse]
token: $impulse_token
url: https://impulse.sec.yandex-team.ru/api/v1
org_id: 9
callback_url: https://impulse.sec.yandex-team.ru/api/v1/webhook/secnotify/startrek/{}?tvm_id=2017557

[language_notify]
enabled = true
queue = DEVTOOLSUP
assignee = rnefyodov
cc = abash

[stat]
robot_login = $stat_login_prodsec
robot_password = $stat_passwd_prodsec
url = https://upload.stat.yandex-team.ru/_api/report/data

[sender]
url = https://sender.yandex-team.ru/api/0
account_slug = ISS
token = $sender_token

[tvm]
# Molly
client_id = $tvm_client_id
client_secret = $tvm_client_secret
destinations = 2008801,2011072

[qloud]
token = $qloud_token
url = https://qloud-ext.yandex-team.ru

[plugins.secreview]
security_abc_id= 909

[plugins.webauth_alerts]
[plugins.blocker_concealer]

[plugins.security_assessor]
nonprocess_queues = INCIDENT,IS,MULTISHIP,QQQQTEST,SECTASK,TAXIEXTAUDIT,TEST

[plugins.secaudit]
first_line = false
allowed_authors = ezaitov,buglloc,tokza,a-abakumov,ya-andrei,kaleda,aleksei-m,tech-robot,robot-c3po,shikari,axlodin,anton-k,robot-lpc,melkikh,enr1g,ichalykin,pavkir
init_molly_scan = true
init_infra_audit = false
infra_assignee = anton-k
force_molly = true
molly_cc = ezaitov
force_csp = true
csp_cc = buglloc
force_tvm = true
tvm_cc = ezaitov
force_pinning = false
pinning_cc = ybuchnev
audit_assignee = buglloc,ilyaon,a-abakumov,anton-k,procenkoeg,shikari,melkikh
default_assignee = ezaitov
mobile_assignee = ybuchnev
browser_sib_assignee = naumov-al
bro_follower = dmgor
taxi_follower = aleksei-m
pcidss_assignee = ezaitov,buglloc,a-abakumov,ilyaon
pcidss_services = 575
infra_component = 26767
mobile_component = 12219
promo_component = 17662
browser_component = 31293
dpia_component = 74825
payment_component = 92354
use_gap = true
init_appchecker_scan = true
init_impulse_repo_scan = true
init_appchecker_package_scan = false
init_appchecker_android_scan = true
init_bandit_scan = true
init_secrets_scan = true
init_yodax_scan = true

[plugins.sectask]
default_assignee = horus
abuse_assignee = akomarov
officers = energen,horus,irmin,buglloc,a-abakumov,anton-k,shikari,gots,kaleda,aleksei-m,axlodin,limetime,procenkoeg,naumov-al,a-maksimova,audap,antonkalinin,dmrussak,strawberry,melkikh,dmitrykovalev,enr1g,ichalykin,pavkir
pastebin_assignee = energen
coresec_assignee = horus,anton-k,a-abakumov,shikari,procenkoeg,melkikh
pki_component = 27161
security_abc_id= 909

[plugins.taxi_security]
queues = TAXISECURITY,TAXICHECK
abc_ids = 909, 31197
slugs = taxi_everyday, TaxiDLPDuty
default_assignee = audap

[plugins.dpia_parser]
default_assignee = dmitrykovalev

[plugins.puncher_checker]
token: $puncher_token
url: https://puncher.yandex-team.ru/api/dynfw/
taxsec_abc_id = 3924
security_abc_id = 909
ISS = ezaitov,buglloc,tokza,a-abakumov,kaleda,aleksei-m,melkikh,shikari,axlodin,energen,horus,irmin,anton-k,shikari,gots,robot-market-infra,strawberry,limetime,naumov-al,procenkoeg,enr1g,ichalykin,pavkir

[plugins.secaudit_impulse_idm]
[plugins.secreview_market]
project_queues = BMP,MARKETPROJECT
" > $1/`basename ${0%.*}.ini`
