cloudquery {
  provider "azure" {
    source  = ""
    version = "v0.4.0"
  }
  connection {
    dsn = "postgresql://cloudquery:${POSTGRES_PASSWORD}@vla-e2xjf24gp8mqx8xx.db.yandex.net:6432/cloudquery?ssl=true"
  }
}

provider "azure" {
  configuration {
    subscriptions = ["50bb42e6-b8ec-4630-bf26-a39598081b4c"]
  }

  env = [
    "AZURE_TENANT_ID=ea0158f7-7081-4678-b0ed-7e79b43f755a",
    "AZURE_CLIENT_ID=6da21db4-7ec4-478f-889e-55e582497ef1",
    "AZURE_CLIENT_SECRET=${AZURE_CLIENT_SECRET}"
  ]

  resources = [
    "authorization.role_assignments",
    "authorization.role_definitions",
    "compute.disks",
    "compute.virtual_machines",
    "container.managed_clusters",
    "keyvault.vaults",
    "monitor.activity_log_alerts",
    "monitor.activity_logs",
    "monitor.diagnostic_settings",
    "monitor.log_profiles",
    "mysql.servers",
    "network.public_ip_addresses",
    "network.security_groups",
    "network.virtual_networks",
    "network.watchers",
    "postgresql.servers",
    "resources.groups",
    "resources.policy_assignments",
    "security.auto_provisioning_settings",
    "security.contacts",
    "security.pricings",
    "security.settings",
    "sql.servers",
    "storage.accounts",
    "subscription.subscriptions",
    "web.apps"
  ]
  enable_partial_fetch = true
}
