package backoff

import "time"

// Strategy is the backoff interface
type Strategy interface {
	// Delay returns the amount of time to wait before the next retry given
	// the number of consecutive failures.
	Delay(err error, n int) time.Duration
}
