from rest_framework.permissions import BasePermission

class IsYandexUser(BasePermission):
    def has_permission(self, request, view):
        if not request.successful_authenticator:
            return False
        if request.user.is_authenticated == True:
            return True
        return False


class IsSuperUser(BasePermission):
    def has_permission(self, request, view):
        if not request.successful_authenticator:
            return False
        if not request.user.is_authenticated == True:
            return False
        if request.user.is_superuser == True:
            return True
        return False


class IsStaffUser(BasePermission):
    def has_permission(self, request, view):
        if not request.successful_authenticator:
            return False
        if not request.user.is_authenticated == True:
            return False
        if request.user.is_staff == True:
            return True
        return False
