//go:build !linux && !freebsd
// +build !linux,!freebsd

package askpass

import (
	"errors"
	"os"
)

func findAskPassProg() (string, error) {
	prog := os.Getenv("SSH_ASKPASS")
	if prog == "" {
		return "", errors.New("you must explicity set env[SSH_ASKPASS]")
	}

	return prog, nil
}
