#[splunktcp:3030]
#connection_host = dns
#compressed = true

# splunk
[splunktcp:3333]
connection_host = ip
#compressed = true

# netflow
[tcp:4444]
disabled = 0
#connection_host = dns
index = temp
sourcetype = bank_netflow


[http]
disabled = 0
# There is no good way to give splunk cap_net_bind_service
port = 1443
enableSSL = 1
#serverCert =  /opt/splunk/etc/apps/TrapdoorConfigs/default/hatch.yandex.net.pem
listenOnIPv6 = yes
# Below is performance related settings. Read: http://dev.splunk.com/view/event-collector/SP-CAAAE6Q
#dedicatedIoThreads = 15
# maxThreads: by default it's equal to $(cat /proc/sys/kernel/threads-max) / 3
#maxThreads = 400000
#maxSockets = 400000

[http://{{ SERVICE }}_syslog]
description = collector for syslog-ng
disabled = 0
connection_host = dns
index = {{ SPLUNK_SYSLOG_INDEX }}
source = {{ SERVICE }}--syslog
sourcetype = {{ SPLUNK_SYSLOG_SOURCETYPE }}
token = {{ HEC_TOKEN }}
useACK = 0

[http://{{ SERVICE }}_hids]
description = collector for osquery logs
disabled = 0
connection_host = dns
index = {{ OSQUERY_INDEX }}
sourcetype = {{ SPLUNK_OSQUERY_SOURCETYPE }}
token = {{ HEC_OSQUERY_TOKEN }}
source = {{ SERVICE }}--osquery_results
useACK = 0


###################### HEC imports ###################### 


[http://{{ SERVICE }}_cilium]
description = collector for syslog-ng
disabled = 0
connection_host = dns
index = {{ SPLUNK_SYSLOG_INDEX }}
source = {{ SERVICE }}--cilium
sourcetype = {{ SPLUNK_CILIUM_SOURCETYPE }}
token = {{ HEC_TOKEN_CILIUM }}
useACK = 0

[http://{{ SERVICE }}_kuber_npe]
description = collector for syslog-ng
disabled = 0
connection_host = dns
index = {{ SPLUNK_SYSLOG_INDEX }}
source = {{ SERVICE }}--k8s--npe
sourcetype = {{ SPLUNK_KUBER_NPE_SOURCETYPE }}
token = {{ HEC_TOKEN_KUBER_NPE }}
useACK = 0

[http://{{ SERVICE }}_kuber_prod]
description = collector for syslog-ng
disabled = 0
connection_host = dns
index = {{ SPLUNK_SYSLOG_INDEX }}
source = {{ SERVICE }}--k8s--prod
sourcetype = {{ SPLUNK_KUBER_PROD_SOURCETYPE }}
token = {{ HEC_TOKEN_KUBER_PROD }}
useACK = 0

[http://{{ SERVICE }}_cloudtrail_prod]
description = collector for syslog-ng
disabled = 0
connection_host = dns
index = {{ SPLUNK_SYSLOG_INDEX }}
source = {{ SERVICE }}--cloudtrail--prod
sourcetype = {{ SPLUNK_TRAIL_PROD_SOURCETYPE }}
token = {{ HEC_TOKEN_TRAIL_PROD }}
useACK = 0

[http://{{ SERVICE }}_cloudtrail_npe]
description = collector for syslog-ng
disabled = 0
connection_host = dns
index = {{ SPLUNK_SYSLOG_INDEX }}
source = {{ SERVICE }}--cloudtrail--npe
sourcetype = {{ SPLUNK_TRAIL_NPE_SOURCETYPE }}
token = {{ HEC_TOKEN_TRAIL_NPE }}

[http://{{ SERVICE }}_s3_audit]
description = collector for syslog-ng
disabled = 0
connection_host = dns
index = {{ SPLUNK_SYSLOG_INDEX }}
source = {{ SERVICE }}--s3_audit
sourcetype = {{ SPLUNK_S3_AUDIT_SOURCETYPE }}
token = {{ HEC_TOKEN_S3_AUDIT }}
useACK = 0

[http://{{ SERVICE }}_pg_audit]
description = collector for syslog-ng
disabled = 0
connection_host = dns
index = {{ SPLUNK_SYSLOG_INDEX }}
source = {{ SERVICE }}--pg_audit
sourcetype = {{ SPLUNK_PG_AUDIT_SOURCETYPE }}
token = {{ HEC_TOKEN_PG_AUDIT }}
useACK = 0
