package abc

const (
	SoxServiceTag  TagID = 2
	GdprServiceTag TagID = 37
)

type TagID = uint64

type Name struct {
	En string `json:"en"`
	Ru string `json:"ru"`
}

type Tag struct {
	ID   uint64 `json:"id"`
	Name Name   `json:"name"`
}

type baseResponse struct {
	Count      int    `json:"count"`
	Next       string `json:"next"`
	TotalPages int    `json:"total_pages"`
}

type tagsResponse struct {
	baseResponse
	Results []struct {
		Tags []Tag `json:"tags"`
	} `json:"results"`
}
