PY23_LIBRARY()

OWNER(buglloc)

PY_SRCS(
    __init__.py
    cli/argparser.py
    cli/__init__.py
    cli/main.py
    formatters/text.py
    formatters/base.py
    formatters/__init__.py
    formatters/_jinja.py
    formatters/json.py
    formatters/console.py
    directives/__init__.py
    directives/directive.py
    directives/block.py
    parser/__init__.py
    parser/raw_parser.py
    parser/nginx_parser.py
    plugins/http_splitting.py
    plugins/ssrf.py
    plugins/add_header_redefinition.py
    plugins/alias_traversal.py
    plugins/__init__.py
    plugins/host_spoofing.py
    plugins/plugin.py
    plugins/valid_referers.py
    plugins/origins.py
    plugins/add_header_multiline.py
    utils/text.py
    utils/__init__.py
    core/config.py
    core/variable.py
    core/severity.py
    core/utils.py
    core/__init__.py
    core/plugins_manager.py
    core/sre_parse/sre_parse.py
    core/sre_parse/__init__.py
    core/sre_parse/sre_constants.py
    core/regexp.py
    core/context.py
    core/manager.py
    core/builtin_variables.py
    core/issue.py
    core/exceptions.py
)

RESOURCE_FILES(
    PREFIX security/yodax/lib/gixy/
    formatters/templates/console.j2
    formatters/templates/text.j2
)

PEERDIR(
    contrib/python/pyparsing
    contrib/python/six
    contrib/python/Jinja2
    contrib/python/cached-property
    contrib/python/ConfigArgParse
)

END()
