package vulnerability

import (
	"context"

	"a.yandex-team.ru/security/impulse/models"
)

type Repository interface {
	FetchByScanID(ctx context.Context, scanID int) (res []*models.Vulnerability, err error)
	UpdateByScanID(ctx context.Context, scanID int, vulnerabilities []*models.Vulnerability) error
	InsertByScanIDAndLastUpdateToken(ctx context.Context, scanID int, lastUpdateToken string,
		vulnerabilities []*models.Vulnerability) ([]*models.Vulnerability, error)
	UpdateFromScanInstanceVulnerabilities(ctx context.Context, scanInstanceID int) error
	FetchByScanInstanceID(ctx context.Context, scanInstanceID int, limit int, offset int) ([]*models.Vulnerability, error)
	GetByVulnerabilityIDAndScanInstanceID(ctx context.Context, vulnerabilityID int,
		scanInstanceID int) (*models.Vulnerability, error)
	GetByVulnerabilityID(ctx context.Context, vulnerabilityID int) (*models.Vulnerability, error)
	ListVulnerabilityCategories(ctx context.Context, scanTypeID, scanID int) ([]*models.VulnerabilityCategoryResponseDTO, error)
	UpdateStatusByIDs(ctx context.Context, status models.StatusType, IDs []int) error
	UpdateTrackerTicketByID(ctx context.Context, trackerTicket string, id int) error
	FetchByScanInstanceIDAndCategoryID(ctx context.Context, scanInstanceID int, categoryID int,
		limit int, offset int) ([]*models.Vulnerability, error)
	FetchByScanInstances(ctx context.Context, scanInstances []*models.ScanInstance,
		limit int, offset int, filterMap map[string]interface{}) ([]*models.Vulnerability, error)
	FetchLatest(ctx context.Context, limit int, offset int, filterMap map[string]interface{}) ([]*models.Vulnerability, error)
}
